import type { TransitionFn } from '@agnos-ui/core/services/transitions/baseTransitions';
/**
 * A transition function that handles vertical collapse animations.
 *
 * This function is created using the `createCollapseTransition` utility with
 * a vertical configuration. It is intended to be used for animating the
 * collapsing and expanding of vertical elements.
 */
export declare const collapseVerticalTransition: TransitionFn;
/**
 * A transition function for collapsing elements horizontally.
 *
 * This function is created using the `createCollapseTransition` utility
 * and is configured with `horizontalConfig`.
 */
export declare const collapseHorizontalTransition: TransitionFn;
